"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assembleActionProps = void 0;
function assembleActionProps(actionMap) {
    var actionProps = {};
    var _loop_1 = function (ownProp) {
        var field = actionMap[ownProp];
        var observerField = field;
        if (field === undefined)
            return "continue";
        if (typeof field === "function") {
            var func = actionMap[ownProp];
            actionProps[ownProp] = func;
        }
        // check if its an observable - TODO typeguard?
        else if (typeof observerField.next === "function") {
            actionProps[ownProp] = function (arg1) {
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                return observerField.next(arg1);
            };
        }
        else {
            throw new Error("unknown property value for property named \"" + ownProp + "\" in action map. Expected function or Observer");
        }
    };
    for (var ownProp in actionMap) {
        _loop_1(ownProp);
    }
    return actionProps;
}
exports.assembleActionProps = assembleActionProps;
//# sourceMappingURL=actions.js.map